<template>
    <ion-page>
        <ion-header :translucent="true">
            <ion-toolbar>
                <ion-buttons slot="start">
                    <ion-menu-button color="primary"></ion-menu-button>
                </ion-buttons>
                <ion-title v-if="userData">{{ userData.name }}</ion-title>
            </ion-toolbar>
        </ion-header>

        <ion-content :fullscreen="true">
            <ion-progress-bar
                v-if="loading"
                type="indeterminate"
            ></ion-progress-bar>
            <grid-wrapper :options="gridOptions" :rowData="rowData">
            </grid-wrapper>
        </ion-content>
    </ion-page>
</template>

<script setup lang="ts">
import {
    IonProgressBar,
    IonContent,
    IonHeader,
    IonMenuButton,
    IonPage,
    IonTitle,
    IonToolbar,
    IonButtons,
} from '@ionic/vue'
import { useMutation, useQuery } from '@vue/apollo-composable'
import gql from 'graphql-tag'
import { computed } from 'vue'
import { GridOptions, RowClickedEvent } from 'ag-grid-community'
import toast from '@/helpers/toast'
import GridButtonDelete from '@/component/Grid/GridButtonDelete.vue'

import 'ag-grid-community/styles/ag-grid.css'
import 'ag-grid-community/styles/ag-theme-quartz.css'
import { RefreshToken } from '@/gql/graphql'
import GridWrapper from '@/component/Grid/GridWrapper.vue'

// Queries

const { loading, refetch, result } = useQuery(
    gql`
        query meWithTokens {
            me {
                appUser {
                    name
                }
                tokenList {
                    id
                    valid
                }
            }
        }
    `,
    null,
    { fetchPolicy: 'network-only' }
)

const { mutate: removeRefreshToken } = useMutation(gql`
    mutation removeRefreshToken($id: ID!) {
        removeRefreshToken(id: $id)
    }
`)

// GRID
const rowData = computed(() => result?.value?.me?.tokenList ?? [])
const userData = computed(() => result?.value?.me?.appUser)

const onDeleteClick = (cellClicked: RowClickedEvent<RefreshToken>) => {
    removeRefreshToken({ id: cellClicked.data?.id }).then(() => {
        refetch()
        toast(cellClicked.data?.id + ' smazáno', 'success')
    })
}

const gridOptions: GridOptions<RefreshToken> = {
    columnDefs: [
        { field: 'id', headerName: 'id', width: 80, pinned: 'left' },
        {
            field: 'valid',
            headerName: 'Validní do',
            type: 'date',
        },
        {
            headerName: 'Akce',
            width: 80,
            filter: false,
            sortable: false,
            cellRendererSelector: () => {
                return {
                    component: GridButtonDelete,
                    params: { onClick: onDeleteClick },
                }
            },
        },
    ],
}
</script>
